#if !defined(_ADATA_DMACORE_H)
#define _ADATA_DMACORE_H

#include "platform.h"
#include "device.h"

/*
** -----------------------------------------------------------
** Client DMA functions
*/

/* Returns TRUE if on error */
extern os_boolean
ADMXRC_EnqueueDma(
  DeviceContext* pDevCtx,
  DmaNode* dmanode,
  os_boolean must_start);

/* Returns TRUE if successfully cancelled */
extern os_boolean
ADMXRC_CancelDma(
  DeviceContext* pDevCtx,
  DmaNode* dmanode);

/*
** End of client DMA functions
** -----------------------------------------------------------
*/

/*
** Called by device open/close handler
*/
extern void
ADMXRC_CleanupDma(
  DeviceContext* pDevCtx);

/*
** Called as a result of a DMA interrupt
*/
extern void
ADMXRC_DmaCompleted(
  DeviceContext* pDevCtx,
  unsigned char chan);

#endif
