static inline os_uint8
os_read_register_le8(OS_BAR_HANDLE* pIgnored, os_uint8* p)
{
  return readb(p);
}

static inline os_uint16
os_read_register_le16(OS_BAR_HANDLE* pIgnored, os_uint16* p)
{
  return readw(p);
}

static inline os_uint32
os_read_register_le32(OS_BAR_HANDLE* pIgnored, os_uint32* p)
{
  return readl(p);
}

static inline void
os_write_register_le8(OS_BAR_HANDLE* pIgnored, os_uint8* p, os_uint8 d)
{
  return writeb(d, p);
}

static inline void
os_write_register_le16
(OS_BAR_HANDLE* pIgnored, os_uint16* p, os_uint16 d)
{
  return writew(d, p);
}

static inline void
os_write_register_le32(OS_BAR_HANDLE* pIgnored, os_uint32* p, os_uint32 d)
{
  return writel(d, p);
}

static inline void
os_read_buffer_le8(OS_BAR_HANDLE* pIgnored, void* d, void* s, unsigned long n)
{
  os_uint8* d8;
  os_uint8* s8;

  d8 = (os_uint8*) d;
  s8 = (os_uint8*) s;
  while (n--) {
    *d8++ = readb(s8++);
  }
}

static inline void
os_read_buffer_le16(OS_BAR_HANDLE* pIgnored, void* d, void* s, unsigned long n)
{
  os_uint16* d16;
  os_uint16* s16;

  n >>= 1;
  d16 = (os_uint16*) d;
  s16 = (os_uint16*) s;
  while (n--) {
    *d16++ = readw(s16++);
  }
}

static inline void
os_read_buffer_le32(OS_BAR_HANDLE* pIgnored, void* d, void* s, unsigned long n)
{
  os_uint32* d32;
  os_uint32* s32;

  n >>= 2;
  d32 = (os_uint32*) d;
  s32 = (os_uint32*) s;
  while (n--) {
    *d32++ = readl(s32++);
  }
}

static inline void
os_write_buffer_le8(OS_BAR_HANDLE* pIgnored, void* d, void* s, unsigned long n)
{
  os_uint8* d8;
  os_uint8* s8;

  d8 = (os_uint8*) d;
  s8 = (os_uint8*) s;
  while (n--) {
    writeb(*s8++, d8++);
  }
  wmb();
}

static inline void
os_write_buffer_le16(OS_BAR_HANDLE* pIgnored, void* d, void* s, unsigned long n)
{
  os_uint16* d16;
  os_uint16* s16;

  n >>= 1;
  d16 = (os_uint16*) d;
  s16 = (os_uint16*) s;
  while (n--) {
    writew(*s16++, d16++);
  }
  wmb();
}

static inline void
os_write_buffer_le32(OS_BAR_HANDLE* pIgnored, void* d, void* s, unsigned long n)
{
  os_uint32* d32;
  os_uint32* s32;

  n >>= 2;
  d32 = (os_uint32*) d;
  s32 = (os_uint32*) s;
  while (n--) {
    writel(*s32++, d32++);
  }
  wmb();
}

static inline os_uint8
os_read_register_8(OS_BAR_HANDLE* pIgnored, os_uint8* p)
{
  return __raw_readb(p);
}

static inline os_uint16
os_read_register_16(OS_BAR_HANDLE* pIgnored, os_uint16* p)
{
  return __raw_readw(p);
}

static inline os_uint32
os_read_register_32(OS_BAR_HANDLE* pIgnored, os_uint32* p)
{
  return __raw_readl(p);
}

static inline void
os_write_register_8(OS_BAR_HANDLE* pIgnored, os_uint8* p, os_uint8 d)
{
  return __raw_writeb(d, p);
}

static inline void
os_write_register_16(OS_BAR_HANDLE* pIgnored, os_uint16* p, os_uint16 d)
{
  return __raw_writew(d, p);
}

static inline void
os_write_register_32(OS_BAR_HANDLE* pIgnored, os_uint32* p, os_uint32 d)
{
  return __raw_writel(d, p);
}

static inline void
os_read_buffer_8(OS_BAR_HANDLE* pIgnored, void* d, const void* s, size_t n)
{
  memcpy_fromio(d, s, n);
}

static inline void
os_read_buffer_16(OS_BAR_HANDLE* pIgnored, void* d, const void* s, size_t n)
{
  memcpy_fromio(d, s, n);
}

static inline void
os_read_buffer_32(OS_BAR_HANDLE* pIgnored, void* d, const void* s, size_t n)
{
  memcpy_fromio(d, s, n);
}

static inline void
os_write_buffer_8(OS_BAR_HANDLE* pIgnored, void* d, const void* s, size_t n)
{
  memcpy_toio(d, s, n);
  wmb();
}

static inline void
os_write_buffer_16(OS_BAR_HANDLE* pIgnored, void* d, const void* s, size_t n)
{
  memcpy_toio(d, s, n);
  wmb();
}

static inline void
os_write_buffer_32(OS_BAR_HANDLE* pIgnored, void* d, const void* s, size_t n)
{
  memcpy_toio(d, s, n);
  wmb();
}
